----------------------------
----------------------------
---- Playing Cards Code ----
----------Card.lua----------
----------------------------

Card = {};

--Card.Create()
--@desc: 	Creates a new instace of this object.
--@param:	Suit - the suit of the card
--@param:	Number - the number of the card
--@param:	Colour - the colour of the card
--@return: 	the new instance.
function Card.Create(Suit, Number, Name)
	local card_obj = {};
	--assign any default vars
	card_obj.suit 		= Suit;
	card_obj.number		= Number;
	card_obj.colour 	= Colour;
	card_obj.name		= Name;
	card_obj.Attribute	= Attribute;
	card_obj.picture	= Picture;
	card_obj.isSelected = false;
	--card_obj.drawable	= Drawable;
	card_obj.drawable	= 0;
	card_obj.PrintCards	= Card.PrintCards;
	
	--This if statement is used to decide the colour
	--of the Card Object being created. If the Suit
	--of the Card being generated is a Spade or a 
	--Club the Colour will automatically be set to
	--Black, else it will be set to red.
	if( Suit == SUIT[1] or Suit == SUIT[4] ) then
		card_obj.colour = COLOUR[2];
	else
		card_obj.colour = COLOUR[1];
	end
	
	--Setting up the deck with card images		
	if( card_obj.suit == SUIT[1] ) then
		card_obj.picture = SPADESPICS[card_obj.number];
	elseif( card_obj.suit == SUIT[2] ) then
		card_obj.picture = HEARTSPICS[card_obj.number];
	elseif( card_obj.suit == SUIT[3] ) then
		card_obj.picture = DIAMSPICS[card_obj.number];
	elseif( card_obj.suit == SUIT[4] ) then
		card_obj.picture = CLUBSPICS[card_obj.number];
	end

	if( card_obj.number == 1 ) then
		card_obj.Attribute = ATTRIBUTES.Reset; --2 card
	elseif( card_obj.number == 6 ) then
		card_obj.Attribute = ATTRIBUTES.Go_Lower; --7 card
	elseif( card_obj.number == 7 ) then
		card_obj.Attribute = ATTRIBUTES.Mirror; --8 card
	elseif( card_obj.number == 9 ) then
		card_obj.Attribute = ATTRIBUTES.Bundem; -- 10 card
	elseif( card_obj.number == 11) then
		card_obj.Attribute = ATTRIBUTES.Queen;
	else
		card_obj.Attribute = nil;
	end
	
	return card_obj;
end

--Card.Print()
--@param: 	self
--@desc:	This function takes in a self argument 
--@desc:	(Player.Hand) and prints out the attributes
--@desc:	of each card in thetable in a concise manner.
--@returns:	nil
function Card.Print(self)
	
	--print("Card Suit: "..self.suit..", Card Number: "..self.number..", Card Colour: "..self.colour);
	print(self.name.." of "..self.suit);
	-- , "..self.name..")  Goes after self.colour
end