----------------------------
----------------------------
---- Playing Cards Code ----
------Opponent_AI.lua-------
----------------------------

Opponent_AI = {};
Opponent_AI.isAggressive = false;
Opponent_AI.isMultiples = false;
Opponent_AI.isCardSorted = false;
function Opponent_AI.OppPlayCards()

	print("Opponent_AI.OppPlayCards()");
	
	local cardTable		  	= nil;
	local tacticalCardTable = nil;
	local unplayableCards 	= {};
	local OppHand			= GLOBAL_VARS.Player2Store.hand;
	local OppHandIdx		= #GLOBAL_VARS.Player2Store.hand;
	local nonPlayableCards	= false;
	local cardPile			= GLOBAL_VARS.CardPile;
	local cardPileIdx		= #GLOBAL_VARS.CardPile;
	local cardsToBePlayed	= GLOBAL_VARS.CardsToBePlayed;
	
	if( cardPile[cardPileIdx] ~= nil or
		cardPile[cardPileIdx].Attribute == nil) then
	--If the last card played is not a Special card
                
		if( #GLOBAL_VARS.Player1Store.hand - OppHandIdx <= 4 or cardPileIdx < 15 ) then  
	--If the human player has 4 or less cards MORE than the AI,
	--or the number of cards in card pile is less than 15,
	--then the Opp AI will play less aggressively as it has less
	--cards than the human and is therefore closer to winning,
	--and there is also no threat of having to pick up a large number of
	--cards.        
			print("OPPONENT IS NOT AGGRESSIVE");
			Opponent_AI.isAggressive = false;
			local function equalNumbers(a,b) 
				if( a.number == b.number ) then
					--Prevents an error where cards
					--of identical rank are swapped
					--ad infinitum
					return a.suit<b.suit 
				end
				return a.number < b.number
			end
			table.sort(OppHand, equalNumbers);
	--This sorts the cards by their number, lowest to highest
	--The second argument is a small comparison function to 
	--customize the sorting.
			
			for i = 1, OppHandIdx do 											
	--This checks the AI hand for any unplayable cards.

				if( (OppHand[i].number < cardPile[cardPileIdx].number and OppHand[i].number ~= 1)) then
					if( cardPile[cardPileIdx].number ~= 6 ) then
						if( OppHand[i].number ~= 7 and OppHand[i].number ~= 9 ) then

	--If a card is lower than the one last played then
	--it's unplayable 
	--Except for certain special cards.

							table.insert(unplayableCards, OppHand[i]);	
							
							for i = 1, #unplayableCards do
								print("PRINTING UNPLAYABLE OBJECT: "..i);
								for k,v in pairs(unplayableCards[i]) do print(k,v) end
							end
	--The unplayable cards are inserted into 'unplayableCards'.
					        nonPlayableCards = true;
					        --break;
						end
					end
				end
			end
			
			if( nonPlayableCards == true ) then								
	--Removes (temporarily) the unplayable cards
				RuleBook.RemoveHandCards(unplayableCards, OppHand);
				nonPlayableCards = false;
			end
			
	--Check for multiples and gets back card(s) to play which it feeds
	--into LastPickupCheck()
			if( #OppHand > 0 ) then
				cardTable = Opponent_AI.MultipleCheck(OppHand);
				if( #cardTable ~= 0 ) then									
	--If there are cards to play
	
	--Perform a further tactical check
	--then remove left over entries from the hand.
					print("CARDTABLE: "..#cardTable);
					for i = 1, #cardTable do print(cardTable[i].picture) end
					
					tacticalCardTable = Opponent_AI.LastPickupCheck(cardTable);
					print("TACTICAL TABLE: "..#tacticalCardTable);
					
					if( #tacticalCardTable > 0 ) then
						for i = 1, #tacticalCardTable do
							table.insert(cardsToBePlayed, tacticalCardTable[i]);
						end
					else
						RuleBook.Pickup(GLOBAL_VARS.Player2Store);
						print("Picking Up");	
						
					end
						
					if( #unplayableCards > 0 ) then							
	--If there are any unplayable cards			
						print("UnPlayable cards going back to hand");
						for i = 1, #unplayableCards do							
	--Insert them all back into the AI hand
							table.insert(OppHand, unplayableCards[i]);
						end		
					end
	--Play them
					RuleBook.PlayCards();
				end
			else
	--If not call the pickup function
								
				if( #unplayableCards > 0 ) then							
	--If there are any unplayable cards			
					print("UnPlayable cards going back to hand");
					for i = 1, #unplayableCards do							
	--Insert them all back into the AI hand
						table.insert(OppHand, unplayableCards[i]);
					end		
				end
				
				RuleBook.Pickup(GLOBAL_VARS.Player2Store);			

				print("Picking Up");
			end
		else
			local function equalNumbers(a,b) 
				if( a.number == b.number ) then
					--Prevents an error where cards
					--of identical rank are swapped
					--ad infinitum
					return a.suit<b.suit 
				end
				return a.number > b.number
			end		
		
			table.sort(OppHand, equalNumbers);
			Opponent_AI.isAggressive = true;
	--Sort from Highest to Lowest; play more aggressively
			
			for i = 1, OppHandIdx do 											
	--A repeat of the previous check
				if( (OppHand[i].number < cardPile[cardPileIdx].number and OppHand[i].number ~= 1)) then
					if( cardPile[cardPileIdx].number ~= 6 ) then
						if( OppHand[i].number ~= 7 and OppHand[i].number ~= 9 ) then
							table.insert(unplayableCards, OppHand[i]);
							for i = 1, #unplayableCards do
								print("UnPlayable: "..i);
								print(unplayable[i].picture);
							end
							
							nonPlayableCards = true;
						end
					end
				end
			end
			
			if( nonPlayableCards == true ) then
				RuleBook.RemoveHandCards(unplayableCards, OppHand);
				nonPlayableCards = false;
			end
			
	--Check for multiples
			if( #OppHand ~= 0 ) then
				cardTable = Opponent_AI.MultipleCheck(OppHand); 				
				if( #cardTable ~= 0 ) then
					print("Playing Cards");
	
					tacticalCardTable = Opponent_AI.LastPickupCheck(cardTable);
					
					if( #tacticalCardTable > 0 ) then
						for i = 1, #tacticalCardTable do
							table.insert(cardsToBePlayed, tacticalCardTable[i]);
						end
					else
						RuleBook.Pickup(GLOBAL_VARS.Player2Store);
						print("Picking Up");	
					end		
					if( #unplayableCards > 0 ) then
						print("UnPlayable cards going back to hand");
						for i = 1, #unplayableCards do
							table.insert(OppHand, unplayableCards[i]);
						end
					end	
					RuleBook.PlayCards();
				end
			else
				if( #unplayableCards > 0 ) then
					print("UnPlayable cards going back to hand");
					for i = 1, #unplayableCards do
						table.insert(OppHand, unplayableCards[i]);
					end
				end				
				RuleBook.Pickup(GLOBAL_VARS.Player2Store);
				print("Picking Up");
			end
		end
	
	elseif( cardPile[cardPileIdx].Attribute == Queen ) then
	--If the last card was a Queen
		for i = 1, OppHandIdx do 	
	--Unplayability check
			if( OppHand[i].number < 11 or
				(OppHand[i].Attribute and 
				OppHand[i].Attribute ~= Attributes.Queen or
				OppHand[i].Attribute ~= Attributes.Reset) ) then	
	--If the card is lower than a Queen, 
	--or is a special card that is not a Queen
	--then it is unplayable
				table.insert(unplayableCards, OppHand[i]);													
				for i = 1, #unplayableCards do
					print("UnPlayable: "..i);
					print(unplayable[i].picture);
				end
				nonPlayableCards = true;																			
			end	
			
			if( nonPlayableCards == true ) then
				RuleBook.RemoveHandCards(unplayableCards, OppHand);
				nonPlayableCards = false;
			end
			
			if( #OppHand ~= 0 ) then
				cardTable = Opponent_AI.MultipleCheck(OppHand); 				
				if( #cardTable ~= 0 ) then
					print("Playing Cards");
	
					tacticalCardTable = Opponent_AI.LastPickupCheck(cardTable);
					
					if( #tacticalCardTable > 0 ) then
						for i = 1, #tacticalCardTable do
							table.insert(cardsToBePlayed, tacticalCardTable[i]);
						end
					else
						RuleBook.Pickup(GLOBAL_VARS.Player2Store);
						print("Picking Up");	
					end			
					if( #unplayableCards > 0 ) then
						print("UnPlayable cards going back to hand");
						for i = 1, #unplayableCards do
							table.insert(OppHand, unplayableCards[i]);
						end
					end	
					RuleBook.PlayCards();
				end
			else
				if( #unplayableCards > 0 ) then
					print("UnPlayable cards going back to hand");
					for i = 1, #unplayableCards do
						table.insert(OppHand, unplayableCards[i]);
					end
				end				
				RuleBook.Pickup(GLOBAL_VARS.Player2Store);
				print("Picking Up");
			end
		end
	elseif( cardPile[cardPileIdx].Attribute == RuleBook.Do_Go_Lower ) then						
	--If last card played was a Go Lower card
		
		for i = 1, OppHandIdx do
			if( OppHand[i].number > 7 or 
				OppHand[i].Attribute == RuleBook.Do_Queen ) then														
	--If the card is greater than an 8 (Mirror, number:7) 
	--or its a special card that is not a reset, go lower,
	--or mirror then it is unplayable		
				table.insert(unplayableCards, OppHand[i]);													
				for i = 1, #unplayableCards do
					print("UnPlayable: "..i);
					print(unplayable[i].picture);
				end
				nonPlayableCards = true;
			end
			
			if( nonPlayableCards == true ) then
				RuleBook.RemoveHandCards(unplayableCards, OppHand);
				nonPlayableCards = false;
			end
			
			if( #OppHand ~= 0 ) then
				cardTable = Opponent_AI.MultipleCheck(OppHand); 				
				if( #cardTable ~= 0 ) then
					print("Playing Cards");
	
					tacticalCardTable = Opponent_AI.LastPickupCheck(cardTable);
					
					if( #tacticalCardTable > 0 ) then
						for i = 1, #tacticalCardTable do
							table.insert(cardsToBePlayed, tacticalCardTable[i]);
						end
					else
						RuleBook.Pickup(GLOBAL_VARS.Player2Store);
						print("Picking Up");	
					end			
					
					if( #unplayableCards > 0 ) then
						print("UnPlayable cards going back to hand");
						for i = 1, #unplayableCards do
							table.insert(OppHand, unplayableCards[i]);
						end
					end	
					RuleBook.PlayCards();
				end
			else
				if( #unplayableCards > 0 ) then
					print("UnPlayable cards going back to hand");
					for i = 1, #unplayableCards do
						table.insert(OppHand, unplayableCards[i]);
					end
				end				
				RuleBook.Pickup(GLOBAL_VARS.Player2Store);
				print("Picking Up");
			end																						
		end
	elseif( cardPile[cardPileIdx].Attribute == RuleBook.Do_Mirror ) then							
	--If the last card played was a Mirror (8) card
		
		for i = 1, cardPileIdx do
			if( cardPile[cardPileIdx-1].Attribute == RuleBook.Do_Go_Lower ) then					
	--If the card played before the 8 was a go lower card
	--then the AI must play by that rule
				for i = 1, OppHandIdx do																		
					if( OppHand[i].number > 7 ) then 
	--An 8 can be played, so any cards with			
	--a number greater than 7 (8 card) are 
	--unplayable.
						table.insert(unplayableCards, OppHand[i]);											
						for i = 1, #unplayableCards do
							print("UnPlayable: "..i);
							print(unplayable[i].picture);
						end
						nonPlayableCards = true;															
		
					end
			
					if( nonPlayableCards == true ) then
						RuleBook.RemoveHandCards(unplayableCards, OppHand);
						nonPlayableCards = false;
					end
					
					if( #OppHand ~= 0 ) then
						cardTable = Opponent_AI.MultipleCheck(OppHand); 				
						if( #cardTable ~= 0 ) then
							print("Playing Cards");
				
							tacticalCardTable = Opponent_AI.LastPickupCheck(cardTable);
							
							if( #tacticalCardTable > 0 ) then
								for i = 1, #tacticalCardTable do
									table.insert(cardsToBePlayed, tacticalCardTable[i]);
								end
							else
								RuleBook.Pickup(GLOBAL_VARS.Player2Store);
								print("Picking Up");	
							end		
							
							if( #unplayableCards > 0 ) then
								print("UnPlayable cards going back to hand");
								for i = 1, #unplayableCards do
									table.insert(OppHand, unplayableCards[i]);
								end
							end	
							RuleBook.PlayCards();
						end
					else
						if( #unplayableCards > 0 ) then
							print("UnPlayable cards going back to hand");
							for i = 1, #unplayableCards do
								table.insert(OppHand, unplayableCards[i]);
							end
						end	
						RuleBook.Pickup(GLOBAL_VARS.Player2Store);
						print("Picking Up");
					end																						
				end
			else																							
	--Otherwise it only matters what the number of the
	--last card was. Anything lower than that card				
	--is unplayable, unless it is a reset card.	
				if( (OppHand[i].number < cardPile[cardPileIdx-1].number) and 
					OppHand[i].Attribute ~= RuleBook.Do_Reset ) then			
				
					table.insert(unplayableCards, OppHand[i]);				
					for i = 1, #unplayableCards do
						print("UnPlayable: "..i);
						print(unplayable[i].picture);
					end			
					nonPlayableCards = true;																			
				end
			
				if( nonPlayableCards == true ) then
					RuleBook.RemoveHandCards(unplayableCards, OppHand);
					nonPlayableCards = false;
				end
				
				if( #OppHand ~= 0 ) then
					cardTable = Opponent_AI.MultipleCheck(OppHand); 				
					if( #cardTable ~= 0 ) then
						print("Playing Cards");
		
						tacticalCardTable = Opponent_AI.LastPickupCheck(cardTable);
						
						if( #tacticalCardTable > 0 ) then
							for i = 1, #tacticalCardTable do
								table.insert(cardsToBePlayed, tacticalCardTable[i]);
							end
						else
							RuleBook.Pickup(GLOBAL_VARS.Player2Store);
							print("Picking Up");	
						end	
						
						if( #unplayableCards > 0 ) then
							print("UnPlayable cards going back to hand");
							for i = 1, #unplayableCards do
								table.insert(OppHand, unplayableCards[i]);
							end
						end	
						RuleBook.PlayCards();
					end
				else
					if( #unplayableCards > 0 ) then
						print("UnPlayable cards going back to hand");
						for i = 1, #unplayableCards do
							table.insert(OppHand, unplayableCards[i]);
						end
					end	
					RuleBook.Pickup(GLOBAL_VARS.Player2Store);
					print("Picking Up");
				end
			end
		end
	elseif( cardPile[cardPileIdx] == nil or 		
			(cardPile[cardPileIdx].Attribute and cardPile[cardPileIdx].Attribute == RuleBook.Do_Reset)) then
	--if the card pile is empty play anything. 
		cardTable = Opponent_AI.MultipleCheck(OppHand); 			

		if( #cardTable ~= nil ) then
			print("Playing Cards");
			
			tacticalCardTable = Opponent_AI.LastPickupCheck(cardTable);
			if( #tacticalCardTable > 0 ) then
				for i = 1, #tacticalCardTable do
					table.insert(cardsToBePlayed, tacticalCardTable[i]);
				end
			else
				RuleBook.Pickup(GLOBAL_VARS.Player2Store);
				print("Picking Up");	
			end
			
			RuleBook.PlayCards();
		end
		
		cardTable = nil;
	end
end

function Opponent_AI.MultipleCheck(hand)
	--This function checks for multiples,
	--it also only returns playable cards
	print("Opponent_AI.MultipleCheck()");
	local cards 	 	= {};
	local tempCard 	  	= {}; 
	local multiples	  	= false;
	local cardPile 		= GLOBAL_VARS.CardPile; 		
	
	print("HAND: "..#hand);
	table.insert(tempCard, hand[1]); 
	--Placing the first card in the hand in a temporary table.
		
	table.remove(hand, 1);	
	print("HAND: "..#hand);
		
	for k,v in pairs(tempCard[1]) do print(k,v) end 
	if( #hand > 1 ) then
		for i = 1, 3 do 
	--For loop of 1 to 3. A limit of 3 because there can only be a maximum of
	--four cards of any kind, and one of those will have been sent to tempCard.
	--If there are two of the same type of card (ie, two 4s)
    --If the multiples aren't special cards	
    --take that card from 'hand' and put it into table 'cards'
    --multiples = true because multiples have been found
			print("*"..hand[1].name);
			print("**"..tempCard[1].name);
			if( hand[i].number == tempCard[1].number ) then 
				print("Multiples present");
				if( hand[i].Attribute == nil ) then 	
					print("MULTIPLES BEING PUT IN HAND");
					print(hand[i].picture);
					table.insert(cards, hand[i]);
					table.remove(hand, i);
					multiples = true;					 
					Opponent_AI.isMultiples = true;
					break;
				elseif( hand[i].Attribute and 
						(hand[i].Attribute ~= RuleBook.Do_Bundem and hand[i].Attribute ~= RuleBook.Do_Queen) ) then 
	--if the card is special, but not a 10 or a queen
	--ignore multiples
					print("SPECIAL MULTIPLES EXIST");
	--Search for a higher card instead of playing a valuable
	--special card multiples
					local x = 0;
					local highCard = 0;
					for i = 1, #hand do
						
						if( hand[i].number >= cardPile[#cardPile].number ) then
							x = x + 1;
							highCard = i;
						end
					end
					
					print("");
					
					if( x > 0 ) then
						return hand[highCard];
					else
						table.insert(cards, tempCard[1]);
						table.remove(tempCard, 1);
						break;
					end
	-- if the card is a 10
	-- if there are 3 or less cards in the hand			
	-- play all multiples			
	-- multiples = true because multiples have been found				
	-- otherwise			
	-- carry on as normal, ignoring multiples as it is not good tactics to play them.			
				elseif( hand[i].Attribute == RuleBook.Do_Bundem) then 
					if( #hand <= 4) then			  	  
						table.insert(cards, hand[i]);
						table.remove(hand, i);
						multiples = true;	
						Opponent_AI.isMultiples = true;
						break;
					else								  
						table.insert(cards, tempCard[1]);
						table.remove(tempCard, 1);
						break;
					end
	-- if the card is a queen
	-- play all multiples
	-- multiples = true because multiples have been found
				elseif( hand[i].Attribute == Attributes.Queen ) then 
					table.insert(cards, hand[i]);
					table.remove(hand, i);
					multiples = true;	
					Opponent_AI.isMultiples = true;
					break;
				end
			else
				print("No Multiples");
	--Searching for other multiples
				local otherMultiples = false;
				
				for i = #hand, 1, -1 do 
					for j = #hand, 1, -1 do
						if( hand[i].number == hand[j].number ) then
							table.insert(cards, hand[j]);
							table.insert(cards, hand[i]);
							otherMultiples = true;
							break;
						end
					end
				end
	--Only play one	
	--there are no multiples
	--carry on as normal		
				for i = 1, #cards do print("CARDS "..i..": "..cards[i].picture) end
				
				if( #cards < 1 ) then
					table.insert(cards, tempCard[1]);
					table.remove(tempCard, 1);
					break;
				else
					if( otherMultiples == true ) then
						return cards;
					else
	--If there are other multiples play them otherwise...
						local x = 0;
	--If there are is more than one card greater than the current number			
						for i = 1, #hand do
							if( hand[i].number >= cardPile[#cardPile].number ) then
								x = x + 1;
							end
						end
						
						if( x > 1 ) then 
							if( tempCard[1].number == cardPile[#cardPile].number ) then
	--If the AI has an equal card play that
								return tempCard[1];
							else
								for i = 1, #tempCard do
									table.insert(hand, tempCard[i]);
								end
								return hand;
	--Return the whole hand for further analysis
							end
						else
	--Otherwise return the temp card
							table.insert(cards, tempCard[1]);
							table.remove(tempCard, 1);
							break;
						end
					end
				end		
			end
		end
	else
		for i = 1, #tempCard do
			table.insert(hand, tempCard[i]);
		end
		return hand;
	end
	--if there are multiples
	--removes them from the 'hand' table.
	if( multiples == true ) then	
		for i = 1, #cards do
			RuleBook.RemoveHandCards(cards, hand);
		end
		
	--resetting
		multiples 	= false;
		count 		= nil;
	end
	
	print("CHECKING cards")
	for i = 1, #cards do print(cards[i].picture) end
	
	return cards; 
	--return card(s) to play
end

function Opponent_AI.LastPickupCheck(hand)
	print("Opponent_AI.LastPickupCheck()");
	--This functions comes after the multiple check
	--and adds another level of tactical analysis to
	--the A.I choosing his hand.
	
	for i = 1, #hand do print (hand[i].picture) end
	local isReset		= false;
	local isMagic		= false;
	local isQueen		= false;
	local isBundem		= false;
	local isGoLower		= false;
	local isMirror 		= false;
	local hasQueen		= false;
	local hasGoLower	= false;
	local hasMirror		= false;
	local hasReset		= false;
	local grtrThanSeven	= false;
	local magic			= 0;
	local reset			= 0;
	local queen			= 0;
	local burn			= 0;
	local goLower		= 0;
	local mirror		= 0;
	local oppQueen		= 0;
	local lowCards		= 0;
	local highCards		= 0;
	local resetOpp		= 0;
	local mirrorOpp		= 0;
	local card			= {};
	local tempCard		= {};
	local lastPickup	= GLOBAL_VARS.LastPickUp;
	local lstPckpName	= GLOBAL_VARS.LastPickupName
	local cardPile		= GLOBAL_VARS.CardPile;
	
	for i = 1, #hand do
		if( hand[i].Attribute == RuleBook.Do_Reset ) then
			print("LAST PICKUP CHECK: RESET CARD PRESENT");
			hasReset = true;
			resetOpp = i;
		end
	end
	
	if resetOpp then print("RESETOPP: "..resetOpp) end
	
	for i = 1, #hand do
		if( hand[i].Attribute == RuleBook.Do_Mirror ) then
			print("LAST PICKUP CHECK: MIRROR CARD PRESENT");
			hasMirror = true;
			mirrorOpp = i;
		end
	end
				
	if( lstPckpName == nil or 
		lstPckpName == GLOBAL_VARS.Player2Store.name) then
		print("PLAY WEAK");
		if( Opponent_AI.isMultiples == false ) then
	--if there are no multiples
			if(	#hand > 1 ) then
				print("MORE THAN ONE CARD PRESENT IN HAND");
				if( hasReset == true ) then
					print("Has reset check");
					local x = 0;
					local y = 0;
					local higherCard = 0;
					
					for i = 1, #hand do
						if( hand[i].number >= cardPile[#cardPile].number ) then 
							x = x + 1;
							print("x = "..x);
							higherCard = i;
						end
						if( cardPile[#cardPile].number ~= 6 ) then
	--If the last card played is not a go lower	
							if( x > 0 ) then
	--If there are cards that can be played that are greater than
	--a reset card, play one of them instead
								print("X is GREATER THAN 0, THERE ARE BETTER CARDS THAN RESETS");
							
								return hand[higherCard];
							else
	--Otherwise play the 2
								print("RETURNING A 2");
								return hand[resetOpp];
							end
						else
							print("IT'S A GO LOWER");
							for i = 1, #hand do
	--Looking for a go lower card to play, as this is better tactically	
								if( hand[i].number == 6 ) then
									goLower = i;
								end
									
								if( hand[i].number <= 6 and hand[i].number ~= 1) then
									x = x + 1;
									if( goLower > 0 ) then 
										print("RETURN GO LOWER");
										return hand[goLower];
	--If it has one return it
									else
										if( x > 0 ) then
											print("RETURN ANY PLAYABLE CARD ");
											return hand[i];	
	--Otherwise return any other card lower than a 7 other than a two
										end
									end
								else
									if( hand[i].number == 1 ) then
										y = y + 1;
										if( y > 0 ) then
	--If that isnt possible and a 2 is in the hand return that
											print("RETURNING A 2");
											return hand[i];
										end
									else 
	--Otherwise just play any playable card 
										print("RETURN ANY PLAYABLE CARD ");
										return hand[1];
									end
								end
							end
						end
					end
				else
					print("PLAYING A CARD NON AGRESSIVELY OR BASED ON RESETS");
	--Resetting Variables
					Opponent_AI.isMultiples = false;
	--A little error catch to stop it returning no cards
					local handNum = 0;
					for i = 1, #hand do
						if( hand[i].number >= cardPile[#cardPile].number ) then
							handNum = i;
							print("RETURNING A CARD EQUAL OR HIGHER TO THE LAST PLAYED");
							print("i = "..i);
							print("handNum "..handNum);
							print("hand[i].Picture: "..hand[i].picture);
							print("hand[handNum].Picture: "..hand[handNum].picture);
							return hand[handNum];
						end 
					end
					--return hand[1];
				end
			elseif( #hand == 1 ) then
				print("ONLY ONE CARD IN HAND");
				return hand[1];
			else
				RuleBook.Pickup(GLOBAL_VARS.Player2Store);
			end
		else
			return hand;
	--return multiples if there are any
		end
	--If the AI picked up last then it can't read anything
	--from the information and exits the function, or if there are
	--multiples to be played, play them instead.
	else
	--Otherwise it can check the cards.
		RuleBook.RemoveHandCards(cardPile, lastPickup);
		--Re-using a function for a separate purpose. The LastPickup table is pruned
		--of cards that have since been replayed. Allowing it to react more accurately
		for i = 1, #lastPickup do
			if( lastPickup[i].Attribute == RuleBook.Do_Reset ) then
				isMagic = true;
				isReset = true;
				reset = reset + 1;
				magic = magic + 1;
			elseif( lastPickup[i].Attribute == RuleBook.Do_Go_Lower ) then
				isMagic = true;
				isGoLower = true;
				goLower = goLower + 1;
				magic = magic + 1;
			elseif( lastPickup[i].Attribute == RuleBook.Do_Mirror ) then
				isMagic = true;
				isMirror = true;
				mirror = mirror + 1;
				magic = magic + 1;
			elseif( lastPickup[i].Attribute == RuleBook.Do_Bundem ) then
				isMagic = true;
				isBundem = true; 
				bundem = bundem + 1;
				magic = magic + 1;
			elseif( lastPickup[i].Attribute == RuleBook.Do_Queen ) then
				isMagic = true;
				isQueen = true;
				oppQueen = oppQueen + 1;
				magic = magic + 1;
			elseif( lastPickup[i].number < 6 ) then
	--if the card is less than a 7
				lowCards = lowCards + 1;
			elseif( lastPickup[i].number > 5 ) then
	--if the card is greater than a 6
				highCards = highCards + 1;
			end
		end	
	end
	
	local lowMinusHigh = lowCards - highCards;
	local highMinuslow = highCards - lowCards;
	local goLowerCard = 0;
	--checks for a go lower card;
	
	for i = 1, #hand do
		if( hand[i].Attribute == RuleBook.Do_Go_Lower ) then
			hasGoLower = true;
			goLowerCard = i;
		end
	end
	
	if( isMagic == true ) then
		if( (isBundem == true and isMirror == true and isGoLower == true) or
			goLower >= 3 or bundem >= 3 or mirror >= 3 or
			oppQueen >= 3 or magic > 3) then
	-- If there are at least 3 magic cards in the last pickup of varying sorts
			if( Opponent_AI.isAggressive == true ) then
				for i = 1, #hand do
					if( hand[i].Attribute == Queen ) then
						hasQueen = true;
						queen = i;
	-- If the AI is aggressive and has a queen
	-- set hasQueen to true and equate queen to i
					end
					
					if( hand[i].number > 6 ) then
	-- If the card is greater than a 7 (number 6)
						table.insert(card, hand[i]);
						grtrThanSeven = true;
					end
					
					if( grtrThanSeven == true ) then
						if( hasQueen == true ) then
							Opponent_AI.isAggressive = false;
							Opponent_AI.isMultiples = false;						
							return hand[queen];
	--If the hand has a queen
	--play it, else look for
	--the first card higher 
	--than 7 else return hand	
						else
							Opponent_AI.isAggressive = false;
							Opponent_AI.isMultiples = false;						
							return card[1];
						end
					else
						return hand[1];
					end
				end
			else
	--If AI is not aggressive return hand unmodified.
				return hand[1];
			end
		elseif( isQueen == true and (#GLOBAL_VARS.Player1Store.hand < 5 or oppQueen > 1) ) then
	--If the opponent has a queen and either the human player is down 
	--to there last cards or there was more than one queen in the 
	--last pickup.
	--And the AI is aggressive
			if( Opponent_AI.isAggressive == true ) then			
				for i = 1, #hand do
					if( hand[i].number > 11 ) then
	--Check the hand for cards greater than a queen and return 
	--the first.
						Opponent_AI.isAggressive = false;
						Opponent_AI.isMultiples = false;
						return hand[i];
					end
				end
			else
	--If AI is not aggressive then return hand unmodified.
				Opponent_AI.isAggressive = false;
				Opponent_AI.isMultiples = false;		
				return hand[1];
			end		
		elseif( lowCards < 3 or highMinuslow > 4) then
	--If player 1 has fewer than 3 low cards (below 7)
	--or the difference between the amount of high and
	--low cards is greater than 4
			if( hasGoLower == true ) then
	--and AI has a goLowerCard, and it's playable then play it.
				if( cardPile[#cardPile].number < 6 ) then
					return hand[goLowerCard];
				else
					return hand[1];
				end
			end
		elseif( lowMinusHigh > 5 ) then
	--If player 1 has a lot more low cards
	--than high and the AI is aggressive 
	--find any card higher than an 8 and lower than
	--an ace (to conserve the most power number card)
	--and play it.
			if( isAggressive == true ) then
				for i = 1, #hand do
					if( magic > 2 and hasQueen == true ) then
						return hand[queen];
	--if the player has more than two magic cards
	--and AI has a queen
	--return a queen to try and make the 
	--opposing player pick up
					end
				end
			else
				if( hasReset == true ) then
					if( cardPile[#cardPile].number > 10 ) then
						for i = 1, #hand do
							if( hand[i].number > 10 ) then
								return hand[i];
							else
								print("PLAYING A MIRROR CARD");
								return hand[mirrorOpp];
	--Otherwise if the opponent AI has a mirror card
	--and the last card at least a Jack, and it has no
	--cards higher than a Jack, play a mirror card.
							end
						end
					end
				end					
			end
		end		
	else
	--if isMagic isn't true then there's no tactical edge, return the first card in hand.
		
		return hand[1];
	end
end

function Opponent_AI.cardChange()
	
	
	if( Opponent_AI.isCardSorted == false ) then
		--Allows the AI to change it's top reserve cards at the start of the game
		--It will look for the strongest cards to reserve for the end
	print("Opponent_AI.cardChange()");	
		local hand = GLOBAL_VARS.Player2Store.hand;
		local topRsv = GLOBAL_VARS.Player2Store.TopResvCards;
		
		if( GLOBAL_VARS.GAME_STATE == GLOBAL_VARS.CARD_CHANGE ) then
			
			local function equalNumbers(a,b) 
				if( a.number == b.number ) then
					--Prevents an error where cards
					--of identical rank are swapped
					--ad infinitum
					return a.suit<b.suit; 
				end
				return a.number > b.number;
			end
			
			table.sort(hand, equalNumbers );
			table.sort(topRsv, equalNumbers );
	
			local all = {};
			
			for i = 1, #hand do
				table.insert(all, hand[i]);
			end
			
			for i = 1, #topRsv do
				table.insert(all, topRsv[i]);
			end
			
			
			local stronger = function(a, b)
			-- attribute cards are always stronger
			-- if both cards are attribute cards sort by rank
				if( (a.attribute and b.attribute) or
					(not a.attribute and not b.attribute) )then
					return a.number > b.number
				end
				
				--If the program gets this far one card has
				--no attribute.
				if( a.Attribute ) then 
					return true; 
					--If a has an attribute return true 
					--(rank it higher than b)
				end
				
				return false; --Otherwise put B before A
			end
		
			table.sort(all, stronger)
			
			for i = 1, #all do
				print("All "..i..": "..all[i].number)
			end
	
			--Strongest cards are saved for last
			for i = 1, GLOBAL_VARS.MaxHand do 
				hand[i] = all[#hand+i];
			end
			
			--Weakest go back into the hand
			for i = 1, GLOBAL_VARS.MaxHand do 
				topRsv[i] = all[i];
			end
		end
	
		Opponent_AI.isCardSorted = true;
	end
--Iterating backwards by 1
--In a double for loop
--This helps avoid some of
--the more subtle errors that can
--occur when looking for cards cards.
end