--InstanceObject example
--Author: Babu Madhikarmi (babu@ndreams.com).
--nDreams Ltd, 4/10/2011
--Description: an example of instantiated objects in Lua.
--[[
	Usage:
	myObj = InstanceObject.Create();
	myObj:Update(dt);
--]]
--**********************************************************************
InstanceObject = {};
InstanceObject.VERSION 	= 0.1;
InstanceObject.DEBUG 	= false;
print("Running InstanceObject.VERSION= " .. tostring(InstanceObject.VERSION))
--**********************************************************************

--InstanceObject.Create()
--@desc: 	Creates a new instace of this object.
--@return: 	the new instance.
function InstanceObject.Create()
	local inst_obj = {};
	--assign any default vars
	inst_obj.name 	= "frank";
	inst_obj.inited = true;
	
	--assign functions (yeah this bit sucks compared to other languages... but lua really isn't OO... le sigh)
	inst_obj.Update 	= InstanceObject.Update;
	inst_obj.SetName 	= InstanceObject.SetName;
	
	return inst_obj;
end

--InstanceObject.SetName()
--@desc: 	Sets the name of this object instance.
--@param:	self (InstanceObject):
--@param:	new_name (string): the new name to assign.
--@return: 	nil
function InstanceObject.SetName(self, new_name)
	self.name = new_name;
end

--InstanceObject.Update()
--@desc: 	Update function for the object,
--@param:	self (InstanceObject):
--@param:	dt (number): delta time between frames. See Home API GetDeltaTime()
--@return: 	nil
function InstanceObject.Update(self, dt)
	--tick
end

