
--StaticClass example
--Author: Babu Madhikarmi (babu@ndreams.com).
--nDreams Ltd, 4/10/2011
--Description: an example of setting up a static class in Lua.
--[[
	Usage 
	StaticClass.Init("something");
	StaticClass.Update(dt);
--]]
--**********************************************************************
StaticClass = {};
StaticClass.VERSION = 0.1
StaticClass.DEBUG 	= false;
StaticClass.inited 	= false;
StaticClass.name 	= nil;

print("Running StaticClass.VERSION= " .. tostring(StaticClass.VERSION))
--**********************************************************************
--StaticClass.Init()
--@desc: 	Initialises the static class.
--@param: 	name (string): the name of this class
--@param: 	age (number): the age of this class.
--@return: 	nil
--	optionals
--	@author: 	babu@ndreams
function StaticClass.Init(name, age)
	--Initialise, and pass through arguments.
	StaticClass.name	= name;
	StaticClass.age		= age;
	
	--once inited completed, set to true
	StaticClass.inited = true
end

--StaticClass.SetAge()
--@desc:	Sets the age of the class.
--@param:	new_age (number): the new age of the class.
--@return:	nil
function StaticClass.SetAge(new_age)
	StaticClass.age	= new_age;
end

--StaticClass.DeInit()
--@desc:	Deinits the class, setting variables to nil and inited to false.
--@return:	nil
function StaticClass.DeInit()
	--once deinited, set to false
	StaticClass.inited = false;
end

--StaticClass.Update()
--@desc:	Update function for the class, taking delta time.
--@param:	dt(number): delta time
--@return:	nil
function StaticClass.Update(dt)
	--we pass through delta
end