----------------------------
----------------------------
---- Playing Cards Code ----
----------------------------
----------------------------

--Loading in other objects and classes
require("Deck");
require("Constants");
require("Player");
require("Card");

--Global variables
GLOBAL_VARS = {};
GLOBAL_VARS.PlayerStore	= Player.Create("Joe"); --Variable used to store the Player object
GLOBAL_VARS.MaxHand		= 5; --Maximum amount of cards Player.Hand can hold

--BuildHand()
--@desc:	This function works by using a for loop to deal a card
--@desc:	into a local variable, then copy the contents of that 
--@desc:	local variable (a playing card) to the Player.hand table.
--@return:	nil
function BuildHand()

	for i = 1, GLOBAL_VARS.MaxHand do
		
		local cardStore = Deck.DealCard();
			
		Player.AddToHand(GLOBAL_VARS.PlayerStore, cardStore);
	end
end

--ShowEm()
--@desc:	This will print out all the cards in the Player.hand
--@desc:	table when this file is run in Command Prompt
function ShowEm()
	
	Player.ShowCards(GLOBAL_VARS.PlayerStore);
	
end

--Calling functions
Deck.Init();
Deck.Shuffle();
BuildHand();
ShowEm();
Deck.DeInit();

table.foreach(Deck.cards, print);
