RuleBook = {};
RuleBook.DEBUG 		= false;
RuleBook.inited 	= false;
RuleBook.Turn		= GLOBAL_VARS.Player1Store;
RuleBook.TurnNum	= 1;
RuleBook.IsBundem	= false;
--**********************************************************************

function RuleBook.Do_Bundem()
	
	--BUNDEM CODE
	print("RuleBook.Do_Bundem()");
	
	for i = 1, #GLOBAL_VARS.CardPile do
		table.remove(GLOBAL_VARS.CardPile, i);
	end
	
	--Should have some code that keeps it the same player's turn
	RuleBook.Turn = RuleBook.Turn;
	print("Deck Burnt");
	print("It's still "..RuleBook.Turn.name.."'s Turn.");
end

function RuleBook.Do_Reset()
	
	RuleBook.TurnChange();	--Change turns at the start of every attribute call
							--so the functions can implement the played card checks against the next player
	print("RuleBook.Do_Reset()");
	print("Deck Reset");
	--Nothing really happens here as the deck is not burnt, the number
end

function RuleBook.Do_Go_Lower()
	
	RuleBook.TurnChange();
	
	print("RuleBook.Do_Go_Lower()");
	
	if( GLOBAL_VARS.CardsToBePlayed[1] ) then					--If there's a card to be played
		if( GLOBAL_VARS.CardsToBePlayed[1].number > 7 ) then	--If that card is greater than an 8 (mirror card/number 7).
			print("You have to play a 7, a Mirror (8), or a card lower than 7");
			RuleBook.RemoveCards();
		else
			RuleBook.MultipleCheck();							--Check if there are multiples
		end
	end
end

function RuleBook.Do_Mirror()
	RuleBook.TurnChange();
	print("RuleBook.Do_Mirror()");
	
	local cardsToBePlayed = GLOBAL_VARS.CardsToBePlayed;
	local cardPile	= GLOBAL_VARS.CardPile;
	
	if( cardsToBePlayed[1] ) then		
		if( cardPile[#cardPile-1].Attribute == RuleBook.Do_Go_Lower ) then	
			print("Go Lower still in effect");					--If the card before the 8 was a go lower then those rules still apply
			
			RuleBook.Do_Go_Lower();
		else																				
			if( (cardsToBePlayed[1].number < cardPile[#cardPile-1].number) or 
				(cardsToBePlayed[1].Attribute ~= RuleBook.Do_Reset) ) then				
																--Otherwise it only matters what the number of the						
																--last card was. Anything lower than that card								
				RuleBook.RemoveCards();							--is unplayable, unless it is a reset card.	
			else
				RuleBook.MultipleCheck();
			end
		end
	end
end

function RuleBook.Do_Queen()
	RuleBook.TurnChange();
	print("RuleBook.Do_Queen()");
	
	local cardsToBePlayed = GLOBAL_VARS.CardsToBePlayed;
	
	if( cardsToBePlayed[1] ) then				
		if( (cardsToBePlayed[1].number < 11) or 
			(cardsToBePlayed[1].Attribute and cardsToBePlayed[1].Attribute ~= RuleBook.Do_Queen) ) then
			print("You can only play Queen, King or Ace");		--If the card to be played is lower than a queen,
																--or a magic card that is not a queen
			RuleBook.RemoveCards()
		else
			RuleBook.MultipleCheck();
		end
	end
end

function RuleBook.MultipleCheck()
	print("RuleBook.MultipleCheck()");
	--This is an initial check to see if there are attempted multiple cards being played
	--and whether not they are playable.
	
	local cardsToBePlayed = GLOBAL_VARS.CardsToBePlayed;
	
	--Checks if there's more than one card being played
	if( #cardsToBePlayed > 1 ) then
		--Then sort by card number
		table.sort(cardsToBePlayed, function(a,b) return a.number<b.number end);
		
		if( cardsToBePlayed[1].number ~= cardsToBePlayed[#cardsToBePlayed].number ) then
			--Making sure the cards to be played are the same number. If not RemoveCards() is called.
			print("You can only play multiple cards if they are the same number");		
			
			RuleBook.RemoveCards();
		else
		
			RuleBook.PlayCards();		
		end
	end
end

function RuleBook.CardPileAndHandCheck()
	
	--This is a check to see if the card pile has 4 multiples
	--in a row, in which case the deck must be burnt, or if
	--there a magic card has been played.
	print("RuleBook.CardPileAndHandCheck()");
	local cardPile	= GLOBAL_VARS.CardPile;
	print("Card pile IDX: "..#cardPile);
	for i = 1, #cardPile do print(cardPile[i].picture) end
	if( #cardPile > 3 ) then
		if( cardPile[#cardPile].number == cardPile[#cardPile-1].number ) then
		--If the number of the last card on the played card pile, and that of the card before it are the same
			if( cardPile[#cardPile-2].number == cardPile[#cardPile-3].number ) then
			--If the number of the 3rd and 4th last cards are the same
				if( cardPile[#cardPile-1].number == cardPile[#cardPile-2].number ) then
				--If the number of the 2nd and 3rd last cards are the same
					print("3");
					RuleBook.Do_Bundem(); --Burn the deck as there are four multiples
				else 					  --Else check if the last played card has an attribute.
					RuleBook.MagicTest();
				end
			else
				RuleBook.MagicTest();
			end
		else
			RuleBook.MagicTest();
		end	
	else
		RuleBook.MagicTest();
	end
end

function RuleBook.MagicTest()
	print("RuleBook.MagicTest()");
	local cardPile = GLOBAL_VARS.CardPile;

	if ( cardPile[#cardPile].Attribute ) then			--One of the most important parts of code in the program. 
		print(cardPile[#cardPile].Attribute)
		print(RuleBook.Do_Bundem)
		--ATTRIBUTES[cardPile[#cardPile].Attribute]()	--This activates the card attributes.
		cardPile[#cardPile].Attribute()
		--[[if( cardPile[#cardPile].Attribute ~= Bundem ) then
			RuleBook.TurnChange();
		end]]
	else												--If not change turns
		RuleBook.TurnChange();
	end
end

function RuleBook.PlayCards()
	
	local cardsToBePlayed = GLOBAL_VARS.CardsToBePlayed;
	local Player1	= GLOBAL_VARS.Player1Store;
	local Player2	= GLOBAL_VARS.Player2Store;
	print("RuleBook.PlayCards()");
	--Remove the selected cards from the player's hand
	print("****"..#cardsToBePlayed);
	if( RuleBook.TurnNum == 1 ) then
		RuleBook.RemoveHandCards(cardsToBePlayed, Player1.hand);
		RuleBook.ReserveCardRules(Player1); --Player picks up
		table.sort(Player1.hand, function(a,b) return a.number<b.number end)
	else
		RuleBook.ReserveCardRules(Player2);
		RuleBook.RemoveHandCards(cardsToBePlayed, Player2.hand);
	end
	print("****"..#cardsToBePlayed);
	for i = 1, #cardsToBePlayed do
		table.insert(GLOBAL_VARS.CardPile, cardsToBePlayed[i]); --Placing all entries in CardsToBePlayed onto CardPile
	end
	
	print("Playing Cards");
	
	for i = 1, #cardsToBePlayed do
		table.remove(cardsToBePlayed, i); --Removing all entries in CardsToBePlayed
	end
	
	print("Cards Played");
	
	RuleBook.CardPileAndHandCheck();	--This calls the function to check for multiples
	
end

function RuleBook.RemoveCards()
	print("RuleBook.RemoveCards()");
	
	for i = 1, #GLOBAL_VARS.CardsToBePlayed do	--The attempted cards are transferred back to the player hand		
		table.insert(GLOBAL_VARS.Player1Store.hand, GLOBAL_VARS.CardsToBePlayed[i]);
	end
	
	for i = 1, #GLOBAL_VARS.CardsToBePlayed do	--And all entries are removed from the CardsToBePlayed table		
		table.remove(GLOBAL_VARS.CardsToBePlayed,i);
	end
	
end

function RuleBook.TurnChange()
	print("RuleBook.TurnChange()");
	playButtonisSelected = false;
	--This changes turns
	--Code is pretty self explanatory
	
	RuleBook.TurnNum = RuleBook.TurnNum * -1;
	--This starts equal to 1.
	
	if( RuleBook.TurnNum == 1 ) then
		RuleBook.Turn = GLOBAL_VARS.Player1Store;
		print("It's "..RuleBook.Turn.name.."'s Turn.");
	elseif( RuleBook.TurnNum == -1 ) then
		RuleBook.Turn = GLOBAL_VARS.Player2Store;
		print("It's "..RuleBook.Turn.name.."'s Turn.");
	end
end

function RuleBook.CardOrder()
	print("RuleBook.CardOrder()");
	local cardPile		= GLOBAL_VARS.CardPile;
	local cardPileIndex = #GLOBAL_VARS.CardPile;
	local cardsToBePlayed = GLOBAL_VARS.CardsToBePlayed
	--This code is an error check for the human player.
	--A similar one exists in the Opponent AI code.
	
	if( cardsToBePlayed[1] ) then
		print("CARD_PILE: "..cardPileIndex);
		if( #cardsToBePlayed == 1 ) then
			if( (cardPile[cardPileIndex] ~= nil) and 
				(cardPile[cardPileIndex].Attribute == nil ) )then
				--If the last card played is either normal or a reset card play the cards
				if( cardPile[cardPileIndex].number and cardsToBePlayed[1].number > cardPile[cardPileIndex].number ) then
					RuleBook.PlayCards();
				else
					RuleBook.RemoveCards();
					print("You must play a card higher than the last one");
				end
			elseif( cardPile[cardPileIndex] == nil or 
					cardPile[cardPileIndex].Attribute and 
					cardPile[cardPileIndex].Attribute == RuleBook.Do_Reset) then
				--If the pile is empty any card can be played
				RuleBook.PlayCards();
			end
		else
			print("MULTIPLES");
			for i = #cardsToBePlayed, 1, -1 do 
				for j = #cardsToBePlayed, 1, -1 do
					if( cardsToBePlayed[i].number ~= cardsToBePlayed[j].number ) then
						table.remove(cardsToBePlayed, j);
						print("You can only play multiples of the same card");
					end
				end
			end
		end
	end
end

function RuleBook.WinCheck(player)
	print("RuleBook.WinCheck()");
	
	print(RuleBook.Turn.name.." Wins");	
	
end

function RuleBook.Pickup(player)

	print("RuleBook.Pickup()");
	
	for i = 1, #GLOBAL_VARS.CardPile do	--Insert all the cards in CardPile into the player's hand
		table.insert(player.hand, GLOBAL_VARS.CardPile[i]);
	end
	
	RuleBook.LastPickUp();				--Call the last pick up function to memorize details of the pick up.
	
	print("Card Pile cards picked up");
	
	for i = 1, #GLOBAL_VARS.CardPile do --Then remove all those entries from CardPile
		table.remove(GLOBAL_VARS.CardPile, i);
	end
	
	print("Entries removed from card pile");
	
	RuleBook.TurnChange();
end
	
function RuleBook.ReserveCardRules(player)
-- This function checks for and implements the reserve card rules
	print("RuleBook.ReserveCardRules()");
	
	local sum = 0;
	
	if( #player.hand < GLOBAL_VARS.MaxHand ) then --If player hand is below the MaxHand
		if( #Deck.cards ~= 0 ) then				--And the deck isn't empty			  
			sum = GLOBAL_VARS.MaxHand - #player.hand;	--Work out how much less it is than MaxHand
			for i = 1, sum do
				table.insert(player.hand, Deck.cards[#Deck.cards]); --And input cards into the hand of that amount
			end

			for i = sum, 1, -1 do							 --Then remove those entries from the deck
				table.remove(Deck.cards, #Deck.cards); 
			end
		else
			if( #player.hand == 0 ) then			--othwerise if the deck is empty and the player has no cards in their hand
				if( #player.TopResvCards ~= 0 ) then --and TopResvCards isn't empty
					for i = 1, #player.TopResvCards do --transfer it's contents to the player's hand
						table.insert(player.hand, player.TopResvCards[i]);
					end
					
					for i = 1, #player.TopResvCards do --then remove those entries from TopResvCards
						table.remove(player.TopResvCards, player.TopResvCards[i]);
					end
				else
					if( #player.BottomResvCards ~= 0 ) then --otherwise, if that option is exhausted perform the same check on BottomResvCards
						table.insert(player.hand, player.BottomResvCards[1]); --and transfer the cards one per check.
						table.remove(player.BottomResvCards, player.BottomResvCards[1]);
					else
						RuleBook.WinCheck(player); --If the player has absolutely no cards then they win the game
					end
				end
			end		
		end	
	else
		print("Nothing to pick up");
	end
end

function RuleBook.LastPickUp()
	--This function saves the contents of the last pickup
	--and the name of the player for the AI to analyse
	print("RuleBook.LastPickUp()");
	
	for i = 1, #GLOBAL_VARS.CardPile do 
		table.insert(GLOBAL_VARS.LastPickUp, GLOBAL_VARS.CardPile[i]);
	end	
	
	GLOBAL_VARS.LastPickUpName = RuleBook.Turn.name;
end

function RuleBook.RemoveHandCards(cardsToBePlayed, playerHand)
	print("RuleBook.RemoveHandCards()");
--This removes the card to be played from the hand
	for i = #cardsToBePlayed, 1, -1 do 
		for j = #playerHand, 1, -1 do
--Iterating backwards by 1
--In a double for loop
--This helps avoid some of
--the more subtle errors that can
--occur when removing cards.
--if entries in the two tables are identical
--remove that entry from the hand.
			if( cardsToBePlayed[i].number == playerHand[j].number and 
				cardsToBePlayed[i].suit == playerHand[j].suit ) then
				table.remove(playerHand, j);
			end
		end
	end
end

function RuleBook.CardSwap()
	
	--Allowing player 1 to change their cards out at the start
	local hand = GLOBAL_VARS.Player1Store.hand;
	local topRsv = GLOBAL_VARS.Player1Store.TopResvCards;
	
	for i = #topRsv, 1, -1 do
		for j = #hand, 1, -1 do
			if( hand[i].isSelected == true and 
				topRsv[j].isSelected == true )then
				--Reversing the i and j so the cards
				--swap out in the right position
				hand[i].isSelected = false;
				topRsv[j].isSelected = false;
				
				local temp = {};
				local temp2 = {};
				
				table.insert(temp, hand[i]);
				table.insert(temp2,topRsv[j]);
				
				table.remove(hand, i);
				table.remove(topRsv, j);
				
				table.insert(hand, i, temp2[1]);
				table.insert(topRsv, j, temp[1]);
			end
		end
	end
end