----------------------------
----------------------------
---- Playing Cards Code ----
----------------------------
----------------------------

--Loading in other objects and classes
require("Player");
require("randomlua");
--Global variables
GLOBAL_VARS = {};
GLOBAL_VARS.Player1Store	= Player.Create("Player 1"); --Variable used to store the Player object
GLOBAL_VARS.Player2Store	= Player.Create("Computer");
GLOBAL_VARS.MaxHand			= 5; --Maximum amount of cards Player.Hand can hold
GLOBAL_VARS.CardPile		= {};
GLOBAL_VARS.CardsToBePlayed = {};
GLOBAL_VARS.LastPickUp		= {};
GLOBAL_VARS.LastPickUpName	= 0;
GLOBAL_VARS.inMainMenu 		= false;
GLOBAL_VARS.gameStart		= false;
GLOBAL_VARS.rulesPage		= false;
GLOBAL_VARS.MENU			= 1;
GLOBAL_VARS.INST			= 2;
GLOBAL_VARS.CARD_CHANGE		= 3;
GLOBAL_VARS.GAME			= 4;
GLOBAL_VARS.NONE			= 5;
GLOBAL_VARS.GAME_STATE		= GLOBAL_VARS.NONE;

require("RuleBook");
require("Card");
require("Deck");
require("Constants");
require("Opponent_AI");

function BuildHand()
	print("BuildHand()");
	--This works by giving one card to the user and then one to the CPU AI.
	--It first fills up the second reserve (face down cards)
	--then the first (face up) and then the hand.
	local cardStore = nil;
	local cardStore2= nil;
	
	for i = 1, GLOBAL_VARS.MaxHand do
		
		cardStore = Deck.DealCard();
	--	table.remove(Deck.card, #Deck.card);
		cardStore2= Deck.DealCard();
	--	table.remove(Deck.card, #Deck.card);
		
		Player.AddBottomReserve(GLOBAL_VARS.Player1Store, cardStore);		
		Player.AddBottomReserve(GLOBAL_VARS.Player2Store, cardStore2);
		
	end
	
	print("Dealt Bottom Reserve cards to both players");
	
	cardStore = nil;
	cardStore2= nil;
	
	for i = 1, GLOBAL_VARS.MaxHand do
	
		cardStore = Deck.DealCard();
		cardStore2= Deck.DealCard();
		
		Player.AddTopReserve(GLOBAL_VARS.Player1Store, cardStore);	
		
		Player.AddTopReserve(GLOBAL_VARS.Player2Store, cardStore2);	
		
	end
	
	print("Dealt Top Reserve cards to both players");
	
	cardStore = nil;
	cardStore2= nil;
	
	for i = 1, GLOBAL_VARS.MaxHand do
	
		cardStore = Deck.DealCard();
		cardStore2= Deck.DealCard();
		
		Player.AddToHand(GLOBAL_VARS.Player1Store, cardStore);		
		Player.AddToHand(GLOBAL_VARS.Player2Store, cardStore2);	
		
	end	
	
	print("Dealt hands to both players");
	
	--Player.ShowCards(GLOBAL_VARS.Player1Store);
	--Player.ShowCards(GLOBAL_VARS.Player2Store);
end

--PrintCardPile()
--@desc:	This will print out all the cards in the CardPile
--@desc:	table when this file is run in Command Prompt
--@desc:	This is mainly for debugging.
function PrintCardPile(cardpile)
	
	local Pile = #cardpile;
	
	for i = 1, Pile do
		Card.Print(cardpile);
	end
end

function GamePlay()
	--print("GamePlay()");
	
	if( RuleBook.TurnNum == 1 ) then
		--Human Gameplay Instructions
		
		if( playButtonisSelected == true ) then	
			RuleBook.CardOrder();
		end
	elseif ( RuleBook.TurnNum == -1 ) then
		--AI Opponents GamePlay Instructions
		for i = 1, #GLOBAL_VARS.Player2Store.hand do
			print(GLOBAL_VARS.Player2Store.hand[i].picture);
		end
		Opponent_AI.OppPlayCards();
		
	end
end

--table.foreach(Deck.cards, print);

function love.load()
--REMOVE EVERYTHING UP TO THE CAPTION WHEN THE STATE MACHINE WORKS		
	--Calling Functions
--[[	Deck.Init();
	
	--Setting up new card images
	for i = 1, #Deck.cards do
		Deck.cards[i].drawable = love.graphics.newImage(Deck.cards[i].picture);
	end
	
	BuildHand();
	
	baseSetup();
	love.graphics.setBackgroundColor(82, 117, 75);
	]]
	-- Sets the title bar
	love.graphics.setCaption("Palace");
	

	--SetState(GLOBAL_VARS.CARD_CHANGE);
	SetState(GLOBAL_VARS.CARD_CHANGE);
	
end

function love.draw()
	GUI();
	
end

function love.update(dt)
	
	if( GLOBAL_VARS.GAME_STATE == GLOBAL_VARS.MENU ) then
	
	elseif( GLOBAL_VARS.GAME_STATE == GLOBAL_VARS.INST ) then
	
	elseif( GLOBAL_VARS.GAME_STATE == GLOBAL_VARS.CARD_CHANGE ) then

		RuleBook.CardSwap();
		Opponent_AI.cardChange();
	elseif( GLOBAL_VARS.GAME_STATE == GLOBAL_VARS.GAME ) then
		
		GamePlay();
		
	end

	--[[
		for i = #GLOBAL_VARS.Player1Store.hand, 1, -1 do
			for j = #GLOBAL_VARS.Player1Store.TopResvCards, 1, -1 do
				if( GLOBAL_VARS.Player1Store.hand[i].isSelected == true and 
					GLOBAL_VARS.Player1Store.TopResvCards[j].isSelected == true )then
					
					GLOBAL_VARS.Player1Store.hand[i].isSelected = false;
					GLOBAL_VARS.Player1Store.TopResvCards[j].isSelected = false;
					local temp = {};
					local temp2 = {};
					
					table.insert(temp, GLOBAL_VARS.Player1Store.hand[i]);
					table.insert(temp2, GLOBAL_VARS.Player1Store.TopResvCards[j]);
					
					table.remove(GLOBAL_VARS.Player1Store.hand, i);
					table.remove(GLOBAL_VARS.Player1Store.TopResvCards, j);
					
					table.insert(GLOBAL_VARS.Player1Store.hand, i, temp2[1]);
					table.insert(GLOBAL_VARS.Player1Store.TopResvCards, j, temp[1]);
				end
			end
		end
]]
end


function baseSetup()
	
	cardBack 	= love.graphics.newImage("back.png");
	
	--Attaining the width and height of the cards from a picture
	cardWidth	= cardBack:getWidth(); 
	cardHeight	= cardBack:getHeight();
	
	spcBtwnCrds = 15; -- space between cards
	
	--Player 1 card places, X positions are in a table, Y is an int

	p1TableX	= {};
	p1TableX[1] = 25;
	p1TableX[2] = p1TableX[1] + cardWidth + spcBtwnCrds;
	p1TableX[3] = p1TableX[2] + cardWidth + spcBtwnCrds;
	p1TableX[4] = p1TableX[3] + cardWidth + spcBtwnCrds;
	p1TableX[5] = p1TableX[4] + cardWidth + spcBtwnCrds;
	
	p1Y	= 490 - spcBtwnCrds;

	--Player 2 card places
	
	p2TableX	= {};
	p2TableX[1] = 25;
	p2TableX[2] = p2TableX[1] + cardWidth + spcBtwnCrds;
	p2TableX[3] = p2TableX[2] + cardWidth + spcBtwnCrds;
	p2TableX[4] = p2TableX[3] + cardWidth + spcBtwnCrds;
	p2TableX[5] = p2TableX[4] + cardWidth + spcBtwnCrds;
	
	p2Y =  love.graphics.getHeight() - (p1Y + cardHeight + spcBtwnCrds); -- screen height - p1Y + card height

	--Player 1 hand
	
	p1HandX	=	p1TableX[5] + spcBtwnCrds + cardWidth;
	
	--Player 2 hand
	p2HandX =	p2TableX[5] + spcBtwnCrds + cardWidth;
	
		--Deck
	deckX	=	p1HandX+spcBtwnCrds;
	deckY	=	p1Y/2;	
	
	--Card Pile
	cardPileX = p1TableX[3];
	cardPileY = deckY;
	cardPileisSelected = false;
	
	--Play Button
	playButtonH = 35;
	playButtonW = 83;
	playButtonX = p1HandX + spcBtwnCrds;
	playButtonY = p1Y - playButtonH - spcBtwnCrds;
	playButtonisSelected = false;
	
	readyButtonW = 105;
	readyButtonisSelected = false;
	
end

function GUI()
	love.graphics.setColor(255,255,255);
	local Player1 = GLOBAL_VARS.Player1Store;
	local Player2 = GLOBAL_VARS.Player2Store;
	
	local cardsToBePlayed = GLOBAL_VARS.CardsToBePlayed;
	
	if( GLOBAL_VARS.GAME_STATE == GLOBAL_VARS.MENU ) then
	
	elseif( GLOBAL_VARS.GAME_STATE == GLOBAL_VARS.INST ) then
		for i = 1, #Player1.BottomResvCards do	
			--Illustrating the bottom reserve cards of player 1
			love.graphics.draw( cardBack, p1TableX[i], p1Y ); --draw the back of a card on the rectangle
		end
	
		--Illustrating Top Reserve cards
		for i = 1, #Player1.TopResvCards do
			--draw the back of a card on the rectangle
			
			love.graphics.draw( Player1.TopResvCards[i].drawable, p1TableX[i], p1Y+spcBtwnCrds );
			if( Player1.TopResvCards[i].isSelected == true ) then
				love.graphics.setColor(250,250,58);
				love.graphics.rectangle("line", p1TableX[i], p1Y + spcBtwnCrds, cardWidth, cardHeight);
				love.graphics.setColor(255,255,255);
			end
		end
		
		for i = 1, #Player2.BottomResvCards do
			--Illustrating the bottom reserve cards of player 2
			love.graphics.rectangle("line",	p2TableX[i], p2Y, cardWidth, cardHeight); --mode,x,y,w,h
			love.graphics.draw( cardBack, p2TableX[i], p2Y );
		end
	
		--Illustrating Top Reserve cards
		for i = 1, #Player2.TopResvCards do
			love.graphics.draw( Player2.TopResvCards[i].drawable, p2TableX[i], p2Y+spcBtwnCrds ); --draw the back of a card on the rectangle
		end
		
		local function equalNumbers(a,b) 
			if( a.number == b.number ) then
				--Prevents an error where cards
				--of identical rank are swapped
				--ad infinitum
				return a.suit<b.suit 
			end
			return a.number > b.number
		end
		
		local function equalNumbers(a,b) 
			if( a.number == b.number ) then
				--Prevents an error where cards
				--of identical rank are swapped
				--ad infinitum
				return a.suit<b.suit; 
			end
			return a.number > b.number;
		end
		
		table.sort(Player1.hand, equalNumbers);
		
		for i = 1, #Player1.hand do
			--Illustrating player 1's hand
			local p1posx = p1HandX + i*spcBtwnCrds;
			love.graphics.draw(Player1.hand[i].drawable,p1posx,p1Y);
		end
		
		for i = 1, #Player2.hand do
			--Illustrating player 2's hand
			p2posx = p2HandX + i*spcBtwnCrds;
			love.graphics.draw(cardBack, p2posx, p2Y);
		end
		
		--Player 1 Selections
		for i = 1, #Player1.hand do
			if( Player1.hand[i].isSelected == true ) then
				love.graphics.setColor(250,250,58);
				local p1HandButtonX = p1HandX + i*spcBtwnCrds; 
				--start position of drawing the card selection
				
				if( i ~= #Player1.hand ) then
					love.graphics.rectangle("line",	p1HandButtonX, p1Y, spcBtwnCrds, cardHeight);
					--the width is only to spcBtwnCrds because it is not the last card in the hand
				else
					love.graphics.rectangle("line",	p1HandButtonX, p1Y, cardWidth, cardHeight);
					--the width is to cardWidth so the whole card in selected, instead of a slither.
				end
			end
		end
		
		love.graphics.setColor(255,255,255);
		
		--Deck
		love.graphics.rectangle("line",	deckX, deckY, cardWidth, cardHeight);
		if( #Deck.cards ~= 0 ) then
			love.graphics.draw(cardBack, deckX, deckY);
		end
		
		--Card Pile
		if( #GLOBAL_VARS.CardPile ~= 0 ) then
			for i = #GLOBAL_VARS.CardPile, -1, #GLOBAL_VARS.CardPile-4 do
				--Illustrating last 4 card in card
				local p1posx = p1HandX + i*spcBtwnCrds;
				love.graphics.draw(GLOBAL_VARS.CardPile[i].drawable,p1posx,p1Y);
			end
			if( GLOBAL_VARS.CardPileisSelected == true ) then
				love.graphics.setColor(0,0,0);
				love.graphics.rectangle("line",	cardPileX, cardPileY, cardPileX + (4 * spcBtwnCrds) + cardWidth, cardHeight);
			end		
		end
		
		--Play Button
		love.graphics.rectangle("fill", playButtonX, playButtonY, playButtonW, playButtonH);
		love.graphics.setColor(0,0,0);
		local indent = 10;
		love.graphics.printf( "Play Cards", playButtonX + indent, playButtonY + indent, playButtonX + playButtonW);
		if( playButtonisSelected == true ) then
			love.graphics.rectangle("line", playButtonX, playButtonY, playButtonW, playButtonH);
		end
	elseif( GLOBAL_VARS.GAME_STATE == GLOBAL_VARS.CARD_CHANGE ) then
		for i = 1, #Player1.BottomResvCards do	
			--Illustrating the bottom reserve cards of player 1
			--love.graphics.rectangle("line",	p1TableX[i], p1Y, cardWidth, cardHeight); --mode,x,y,w,h
			love.graphics.draw( cardBack, p1TableX[i], p1Y ); --draw the back of a card on the rectangle
		end
		
		--Illustrating Top Reserve cards
		for i = 1, #Player1.TopResvCards do
			--draw the back of a card on the rectangle
			
			love.graphics.draw( Player1.TopResvCards[i].drawable, p1TableX[i], p1Y+spcBtwnCrds );
			if( Player1.TopResvCards[i].isSelected == true ) then
				love.graphics.setColor(250,250,58);
				love.graphics.rectangle("line", p1TableX[i], p1Y + spcBtwnCrds, cardWidth, cardHeight);
				love.graphics.setColor(255,255,255);
			end
		end
		
		for i = 1, #Player2.BottomResvCards do
			--Illustrating the bottom reserve cards of player 2
			love.graphics.rectangle("line",	p2TableX[i], p2Y, cardWidth, cardHeight); --mode,x,y,w,h
			love.graphics.draw( cardBack, p2TableX[i], p2Y );
		end

		--Illustrating Top Reserve cards
		for i = 1, #Player2.TopResvCards do
			love.graphics.draw( Player2.TopResvCards[i].drawable, p2TableX[i], p2Y+spcBtwnCrds ); --draw the back of a card on the rectangle
		end
		
		local function equalNumbers(a,b) 
			if( a.number == b.number ) then
				--Prevents an error where cards
				--of identical rank are swapped
				--ad infinitum
				return a.suit<b.suit; 
			end
			return a.number > b.number;
		end
		
		table.sort(Player1.hand, equalNumbers);
		
		for i = 1, #Player1.hand do
			--Illustrating player 1's hand
			local p1posx = p1HandX + i*spcBtwnCrds;
			love.graphics.draw(Player1.hand[i].drawable,p1posx,p1Y);
		end
		
		for i = 1, #Player2.hand do
			--Illustrating player 2's hand
			p2posx = p2HandX + i*spcBtwnCrds;
			love.graphics.draw(cardBack, p2posx, p2Y);
		end
		
		--Player 1 Selections
		for i = 1, #Player1.hand do
			if( Player1.hand[i].isSelected == true ) then
				love.graphics.setColor(250,250,58);
				local p1HandButtonX = p1HandX + i*spcBtwnCrds; 
				--start position of drawing the card selection
				
				if( i ~= #Player1.hand ) then
					love.graphics.rectangle("line",	p1HandButtonX, p1Y, spcBtwnCrds, cardHeight);
					--the width is only to spcBtwnCrds because it is not the last card in the hand
				else
					love.graphics.rectangle("line",	p1HandButtonX, p1Y, cardWidth, cardHeight);
					--the width is to cardWidth so the whole card in selected, instead of a slither.
				end
			end
		end
		
		love.graphics.setColor(255,255,255);
	
		--Deck
		love.graphics.rectangle("line",	deckX, deckY, cardWidth, cardHeight);
		
		if( #Deck.cards ~= 0 ) then
			love.graphics.draw(cardBack, deckX, deckY);
		end
		
		--Ready Button
		love.graphics.rectangle("fill", playButtonX, playButtonY, readyButtonW, playButtonH);
		love.graphics.setColor(0,0,0);
		local indent = 10;
		love.graphics.printf( "Ready To Play", playButtonX + indent, playButtonY + indent, playButtonX + playButtonW);
		
		if( readyButtonisSelected == true ) then
			love.graphics.rectangle("line", playButtonX, playButtonY, readyButtonW, playButtonH);
		end
		
	elseif( GLOBAL_VARS.GAME_STATE == GLOBAL_VARS.GAME ) then
	
		for i = 1, #Player1.BottomResvCards do	
			--Illustrating the bottom reserve cards of player 1
			love.graphics.draw( cardBack, p1TableX[i], p1Y ); --draw the back of a card on the rectangle
		end
		
		--Illustrating Top Reserve cards
		for i = 1, #Player1.TopResvCards do
			--draw the back of a card on the rectangle
			
			love.graphics.draw( Player1.TopResvCards[i].drawable, p1TableX[i], p1Y+spcBtwnCrds );
			if( Player1.TopResvCards[i].isSelected == true ) then
				love.graphics.setColor(250,250,58);
				love.graphics.rectangle("line", p1TableX[i], p1Y + spcBtwnCrds, cardWidth, cardHeight);
				love.graphics.setColor(255,255,255);
			end
		end
		
		for i = 1, #Player2.BottomResvCards do
			--Illustrating the bottom reserve cards of player 2
			love.graphics.rectangle("line",	p2TableX[i], p2Y, cardWidth, cardHeight); --mode,x,y,w,h
			love.graphics.draw( cardBack, p2TableX[i], p2Y );
		end
	
		--Illustrating Top Reserve cards
		for i = 1, #Player2.TopResvCards do
			love.graphics.draw( Player2.TopResvCards[i].drawable, p2TableX[i], p2Y+spcBtwnCrds ); --draw the back of a card on the rectangle
		end
		
		local function equalNumbers(a,b) 
			if( a.number == b.number ) then
				--Prevents an error where cards
				--of identical rank are swapped
				--ad infinitum
				return a.suit<b.suit; 
			end
			return a.number > b.number;
		end
		
		table.sort(Player1.hand, equalNumbers);
		
		for i = 1, #Player1.hand do
			--Illustrating player 1's hand
			local p1posx = p1HandX + i*spcBtwnCrds;
			love.graphics.draw(Player1.hand[i].drawable,p1posx,p1Y);
		end
		
		for i = 1, #Player2.hand do
			--Illustrating player 2's hand
			local p2posx = p2HandX + i*spcBtwnCrds;
			love.graphics.draw(cardBack, p2posx, p2Y);
		end
		
		--Player 1 Selections
		for i = 1, #Player1.hand do
			if( Player1.hand[i].isSelected == true ) then
				love.graphics.setColor(250,250,58);
				local p1HandButtonX = p1HandX + i*spcBtwnCrds; 
				--start position of drawing the card selection
				
				if( i ~= #Player1.hand ) then
					love.graphics.rectangle("line",	p1HandButtonX, p1Y, spcBtwnCrds, cardHeight);
					--the width is only to spcBtwnCrds because it is not the last card in the hand
				else
					love.graphics.rectangle("line",	p1HandButtonX, p1Y, cardWidth, cardHeight);
					--the width is to cardWidth so the whole card in selected, instead of a slither.
				end
			end
		end
		
		love.graphics.setColor(255,255,255);
		
		--Deck
		love.graphics.rectangle("line",	deckX, deckY, cardWidth, cardHeight);
		if( #Deck.cards ~= 0 ) then
			love.graphics.draw(cardBack, deckX, deckY);
		end
		
		--Card Pile
		if( #GLOBAL_VARS.CardPile ~= 0 ) then
			if( #GLOBAL_VARS.CardPile > 4 ) then
				for i = #GLOBAL_VARS.CardPile, #GLOBAL_VARS.CardPile-4, -1 do
					--Illustrating last 4 cards in cardpile
					local p1posx = cardPileX + i*spcBtwnCrds;
					love.graphics.draw(GLOBAL_VARS.CardPile[i].drawable,p1posx,cardPileY);
					
					if( GLOBAL_VARS.CardPileisSelected == true ) then
						love.graphics.setColor(0,0,0);
						love.graphics.rectangle("line",	cardPileX, cardPileY, cardPileX + (4 * spcBtwnCrds) + cardWidth, cardHeight);
					end		
				end
			else
				
				--if there are less than 4 cards
				
				for i = #GLOBAL_VARS.CardPile, 1, -1 do
					local p1posx = cardPileX + i*spcBtwnCrds;
					love.graphics.draw(GLOBAL_VARS.CardPile[i].drawable,p1posx,cardPileY);					
				end
			end
			
			if( GLOBAL_VARS.CardPileisSelected == true ) then
				love.graphics.setColor(0,0,0);
				love.graphics.rectangle("line",	cardPileX, cardPileY, cardPileX + (#GLOBAL_VARS.CardPile  * spcBtwnCrds) + cardWidth, cardHeight);
			end		
		end
		
		--Play Button
		love.graphics.rectangle("fill", playButtonX, playButtonY, playButtonW, playButtonH);
		love.graphics.setColor(0,0,0);
		local indent = 10;
		love.graphics.printf( "Play Cards", playButtonX + indent, playButtonY + indent, playButtonX + playButtonW);
		if( playButtonisSelected == true ) then
			love.graphics.rectangle("line", playButtonX, playButtonY, playButtonW, playButtonH);
		end
	end
end

function MainMenu()
	
end

function Rules()

end

function love.mousereleased(x, y, button)
	--This function handles the 'buttons'
	local Player1 = GLOBAL_VARS.Player1Store;
	local cardsToBePlayed = GLOBAL_VARS.CardsToBePlayed;
	
	if( GLOBAL_VARS.GAME_STATE == GLOBAL_VARS.MENU ) then
	
	elseif( GLOBAL_VARS.GAME_STATE == GLOBAL_VARS.INST ) then
	
	elseif( GLOBAL_VARS.GAME_STATE == GLOBAL_VARS.CARD_CHANGE ) then
		--Making the hands completely selectable
		
		if( RuleBook.TurnNum == 1 ) then
			for i = 1, #Player1.hand do
				local p1HandButtonX = p1HandX + i*spcBtwnCrds;
				if( i ~= #Player1.hand ) then
					if( x >= p1HandX+spcBtwnCrds and x <= p1HandButtonX+spcBtwnCrds ) then
						if( y >= p1Y and y <= p1Y+cardHeight ) then
							print(i);
							if( Player1.hand[i].isSelected == false ) then
								Player1.hand[i].isSelected = true;
								table.insert(cardsToBePlayed, Player1.hand[i]);
								break;
							else
								Player1.hand[i].isSelected = false;
								RuleBook.RemoveHandCards(Player1.hand, cardsToBePlayed);
								--The arguments to this function would typically be switched, but the function
								--works the same way when the arguments are reversed to deselect cards
							end
							print(Player1.hand[i].isSelected);					
							break;
						end
					end
				else--making the last card completely selectable
					if( x >= p1HandX+spcBtwnCrds and x <= p1HandButtonX+cardWidth ) then
						if( y >= p1Y and y <= p1Y+cardHeight ) then
							print(i);
							if( Player1.hand[i].isSelected == false ) then
								Player1.hand[i].isSelected = true;
								table.insert(cardsToBePlayed, Player1.hand[i]);
								break;								
							else
								Player1.hand[i].isSelected = false;
								RuleBook.RemoveHandCards(Player1.hand, cardsToBePlayed);
							end	
							print(Player1.hand[i].isSelected);
							break;
						end
					end
				end
			end
		end
		
		--Card Pile
		if( #GLOBAL_VARS.CardPile ~= 0 ) then
			if( x >= cardPileX and x <= cardPileX+cardWidth ) then
				if( y >= cardPileY and y<= cardPileY + cardHeight ) then
					GLOBAL_VARS.cardPileisSelected = true;
					RuleBook.Pickup(Player1);
				end
			end
		end	
		
		--Ready Button
		if( x >= playButtonX and x <= playButtonX + readyButtonW ) then
			if( y >= playButtonY and y <= playButtonY + playButtonH ) then
				if( readyButtonisSelected == false) then	
					readyButtonisSelected = true;
					
					--Removing any left over cards
					for i = #cardsToBePlayed, 1, -1 do
						table.remove(cardsToBePlayed, i);

					end
					
					for i = 1, #Player1.hand do
						Player1.hand[i].isSelected = false;
						Player1.TopResvCards[i].isSelected = false;
					end
					
					SetState(GLOBAL_VARS.GAME);
				else
					readyButtonisSelected = false;
				end
			end
		end
		
		--TopResvCards selectable
		for i = 1, #Player1.TopResvCards do
			if( x >= p1TableX[i] and x <= p1TableX[i] + cardWidth ) then
				if( y >= p1Y + spcBtwnCrds and y <= p1Y + spcBtwnCrds + cardHeight ) then
					print(i);
					if( Player1.TopResvCards[i].isSelected == false ) then
						Player1.TopResvCards[i].isSelected = true;
					else
						Player1.TopResvCards[i].isSelected = false; 
					end
				end
			end
		end	
		
	elseif( GLOBAL_VARS.GAME_STATE == GLOBAL_VARS.GAME ) then
		
		if( RuleBook.TurnNum == 1 ) then
			--Making the hand selectable
			for i = 1, #Player1.hand do
				local p1HandButtonX = p1HandX + i*spcBtwnCrds;
				if( i ~= #Player1.hand ) then
					if( x >= p1HandX+spcBtwnCrds and x <= p1HandButtonX+spcBtwnCrds ) then
						if( y >= p1Y and y <= p1Y+cardHeight ) then
							print(i);
							if( Player1.hand[i].isSelected == false ) then
								Player1.hand[i].isSelected = true;
								table.insert(cardsToBePlayed, Player1.hand[i]);
							else
								Player1.hand[i].isSelected = false;
								RuleBook.RemoveHandCards(Player1.hand, cardsToBePlayed);
								--The arguments to this function would typically be switched, but the function
								--works the same way when the arguments are reversed to deselect cards
							end
							print(Player1.hand[i].isSelected);					
							break;
						end
					end
				else--making the last card completely selectable
					if( x >= p1HandX+spcBtwnCrds and x <= p1HandButtonX+cardWidth ) then
						if( y >= p1Y and y <= p1Y+cardHeight ) then
							print(i);
							if( Player1.hand[i].isSelected == false ) then
								Player1.hand[i].isSelected = true;
								table.insert(cardsToBePlayed, Player1.hand[i]);
							else
								Player1.hand[i].isSelected = false;
								RuleBook.RemoveHandCards(Player1.hand, cardsToBePlayed);
							end	
							print(Player1.hand[i].isSelected);
							break;
						end
					end
				end
			end
		end
	
		--Card Pile
		if( #GLOBAL_VARS.CardPile ~= 0 ) then
			if( x >= cardPileX and x <= cardPileX+cardWidth ) then
				if( y >= cardPileY and y<= cardPileY + cardHeight ) then
					GLOBAL_VARS.cardPileisSelected = true;
					RuleBook.Pickup(Player1);
				end
			end
		end
		
		--Play Button
		if( x >= playButtonX and x <= playButtonX + playButtonW ) then
			if( y >= playButtonY and y <= playButtonY + playButtonH ) then
				if( playButtonisSelected == false) then	
					playButtonisSelected = true;
				else
					playButtonisSelected = false;
				end
			end
		end
	end
end

function SetState(newState)
	print("SetState()");
	GLOBAL_VARS.GAME_STATE = newState;
	
	if( GLOBAL_VARS.GAME_STATE == MENU ) then
		print("MENU");
	elseif( GLOBAL_VARS.GAME_STATE == GLOBAL_VARS.INST ) then
		print("INST");
	elseif( GLOBAL_VARS.GAME_STATE == GLOBAL_VARS.CARD_CHANGE ) then
		print("CARD_CHANGE");
		love.graphics.setBackgroundColor(82, 117, 75);
		Deck.Init();
		
		--Setting up new card images
		for i = 1, #Deck.cards do
			Deck.cards[i].drawable = love.graphics.newImage(Deck.cards[i].picture);
		end
		
		BuildHand();
		
		baseSetup();

	elseif( GLOBAL_VARS.GAME_STATE == GLOBAL_VARS.GAME ) then
		print("GAME");
	end
end
-- This calls the attribute functions.
-- Probably needs to go somewhere else.
-- Needs to be explicity linked to the
-- last card played in card pile
--	if card.attribute then
--  	ATTRIBUTE[card.attribute]();
--	end

